// ExternalFunctionLibraryManager.h: interface for the CExternalFunctionLibraryManager class.
//
//////////////////////////////////////////////////////////////////////

/*
   Copyright 2013 Tony Kennedy, Ventana Systems UK

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

#if !defined(AFX_EXTERNALFUNCTIONLIBRARYMANAGER_H__1D6E9237_E0AF_43F3_BDDD_8905585A5A74__INCLUDED_)
#define AFX_EXTERNALFUNCTIONLIBRARYMANAGER_H__1D6E9237_E0AF_43F3_BDDD_8905585A5A74__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef NOLOG
#include ".\ezutf_src\textfile.h"
#endif

class CExternalFunctionLibraryManager : public CObject  
{
public:
	CExternalFunctionLibraryManager(CString vensiminifile, int ext_version);
	virtual ~CExternalFunctionLibraryManager();

	void CExternalFunctionLibraryManager::FindAndRenameDuplicateFunctions();
	void CExternalFunctionLibraryManager::SetUpFunctionIDs();
	CExternalFunctionLibrary_Function* CExternalFunctionLibraryManager::FindFunctionby_i(int i);
	void CExternalFunctionLibraryManager::WriteLogEntry(CString strLogEntry);

private:
	CTypedPtrArray <CObArray,CExternalFunctionLibrary*> m_arrExtFunc;
	CExternalFunctionLibrary* GetLibByFuncID(int funcid);
	//int m_nCurrentLib;

#ifndef NOLOG
	TextFile *m_pLogFile;
	CString m_strLogFileName;
#endif
	long CExternalFunctionLibraryManager::OpenLogFile(BOOL bAppend);
	void CExternalFunctionLibraryManager::CloseLogFile();


public:
	int SetAllGV(GLOB_VARS *vgv);
	int VensimExternal(VV *val,int nval,int funcid);
	int SimulationShutdown(int finalflag);
	int SimulationSetup(int iniflag);
	int UserDefinition(int i,unsigned char **sym,unsigned char **argument_desc,int *num_arg,int *num_vector,int *func_index,int *dim_act,int *modify,int *num_loop,int *num_literal,int *num_lookup);
	// Check EXTERNAL_VERSION for libs - match to manager
	int CheckAllVersionInfo(int);
	// Check funcversion_info
	int CheckAllFuncversionInfo(void);
};

#endif // !defined(AFX_EXTERNALFUNCTIONLIBRARYMANAGER_H__1D6E9237_E0AF_43F3_BDDD_8905585A5A74__INCLUDED_)
