// MultiExtLib.h : main header file for the MULTIEXTLIB DLL
//

/*
   Copyright 2013 Tony Kennedy, Ventana Systems UK

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

#if !defined(AFX_MULTIEXTLIB_H__96AF5E94_6FF4_4A83_8948_B91A2B7FEB0F__INCLUDED_)
#define AFX_MULTIEXTLIB_H__96AF5E94_6FF4_4A83_8948_B91A2B7FEB0F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols


/////////////////////////////////////////////////////////////////////////////
// CMultiExtLibApp
// See MultiExtLib.cpp for the implementation of this class
//

class CMultiExtLibApp : public CWinApp
{
public:
	CMultiExtLibApp();
private:
	CExternalFunctionLibraryManager *m_pExtFuncManager;

public:
	int SetAllGV(GLOB_VARS *vgv);
	int VensimExternal(VV *val,int nval,int funcid);
	int SimulationShutdown(int finalflag);
	int SimulationSetup(int iniflag);
	int UserDefinition(int i,unsigned char **sym,unsigned char **argument_desc,int *num_arg,int *num_vector,int *func_index,int *dim_act,int *modify,int *num_loop,int *num_literal,int *num_lookup);
	// Check EXTERNAL_VERSION for all libs
	int CheckAllVersionInfo(int);
	// Check funcversion_info for all libs
	int CheckAllFuncversionInfo(void);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMultiExtLibApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CMultiExtLibApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MULTIEXTLIB_H__96AF5E94_6FF4_4A83_8948_B91A2B7FEB0F__INCLUDED_)
